local lg = love.graphics

player = {x, y, img}
canMove = {left = true, right = true, up = true, down = true}
wallImg = nil
walls = { }

--###############################################################--
function love.load()
	player.img = lg.newImage('player.png')
	wallImg = lg.newImage('wall.png')
	
	player.x = 10
	player.y = 25
	
	createWalls() -- Can I load things this way? Sometimes it works sometimes not
end

function love.update() --I think the problem is in here
	playerInput()
	
	for i, wall in ipairs(walls) do -- specifically here
		x1, y1, w1, h1 = player.x, player.y, player.img:getWidth(), player.img:getHeight()
		x2, y2, w2, h2 = wall.x, wall.y, wall.img:getWidth(), wall.img:getHeight()
		
		colCheck()
	end
end  

function love.draw()
	for i, wall in ipairs(walls) do
		lg.draw(wall.img, wall.x, wall.y)
	end
	
	lg.draw(player.img, player.x, player.y)
	
end

--###############################################################--

function createWalls() --This is where the walls are created
	newWall1 = {x = 50, y = (160 - (wallImg:getHeight()/2)), img = wallImg}
	table.insert(walls, newWall1)
	
	newWall2 = {x = 250, y = (160 - (wallImg:getHeight()/2)), img = wallImg}
	table.insert(walls, newWall2)
end 

function playerInput() --Ability for player to move is tied to the colCheck function outputs
	if love.keyboard.isDown('left', 'a') then
		if player.x > 0 and canMove.left then
			player.x = player.x - 2
		end
	end
	
	if love.keyboard.isDown('right','d') then 
		if player.x < (lg.getWidth() - player.img:getWidth()) and canMove.right then
			player.x = player.x + 2
		end
	end
	
	if love.keyboard.isDown('up', 'w') then
		if player.y > 0 and canMove.up then
			player.y = player.y - 2
		end
	end
	
	if love.keyboard.isDown('down','s') then 
		if player.y < (lg.getHeight() - player.img:getHeight()) and canMove.down then
			player.y = player.y + 2
		end
	end
end 

function colCheck() --This is the main collision function that utilises the below functions
	
	if collisionLeft(x1, y1, w1, h1,  x2, y2, w2, h2) then
		canMove.left = false
	else
		canMove.left = true
	end
	
	if collisionRight(x1, y1, w1, h1,  x2, y2, w2, h2) then
		canMove.right = false
	else
		canMove.right = true
	end
	
	if collisionTop(x1, y1, w1, h1,  x2, y2, w2, h2) then
		canMove.up = false
	else
		canMove.up = true
	end
	
	if collisionBottom(x1, y1, w1, h1,  x2, y2, w2, h2) then
		canMove.down = false
	else
		canMove.down = true
	end
		
end 

-- Problem is probably not with the code below

--###############################################################--

function collisionLeft(x1, y1, w1, h1,  x2, y2, w2, h2)
	return 	x1-3 <= x2+w2 and
         	x2 < x1+w1 and
        	y1 <= y2+h2 and
        	y2 < y1+h1
end

function collisionRight(x1, y1, w1, h1,  x2, y2, w2, h2)
	return 	x1 <= x2+w2 and
			x2-3 <= x1+w1 and
			y1 <= y2+h2 and
			y2 < y1+h1
end

function collisionBottom(x1, y1, w1, h1,  x2, y2, w2, h2)
	return 	x1 <= x2+w2 and
			x2 < x1+w1 and
			y1 <= y2+h2 and
			y2-3 <= y1+h1
end

function collisionTop(x1, y1, w1, h1,  x2, y2, w2, h2)
	return 	x1 <= x2+w1 and
			x2 < x1+w1 and
			y1-3 <= y2+h2 and
			y2 < y1+h1
end

--###############################################################--